DECLARE
   CURSOR        emp_cr IS 
                    SELECT empno,sal,deptno FROM emp FOR UPDATE;
   emp_rec       emp_cr%ROWTYPE;
   dept_up       NUMBER;
   no            NUMBER;
   message       VARCHAR2(512);
   sal_no_data   EXCEPTION;
   fetch_out     EXCEPTION;
   PRAGMA EXCEPTION_INIT (fetch_out,-1002);
BEGIN
   OPEN emp_cr;
      LOOP
         BEGIN
            FETCH emp_cr INTO emp_rec;
            EXIT WHEN emp_cr%NOTFOUND;
               IF emp_rec.sal IS NULL
                  THEN RAISE sal_no_data; 
               END IF;
                  CASE emp_rec.deptno
                     WHEN 10 THEN dept_up := 2.0;
                     WHEN 20 THEN dept_up := 2.5;
                     WHEN 30 THEN dept_up := 3.0;
                  ELSE dept_up := 1.0;
                  END CASE;
               UPDATE emp SET sal = TRUNC(sal * dept_up)
               WHERE CURRENT OF emp_cr;
         EXCEPTION
            WHEN sal_no_data
            THEN UPDATE emp SET sal = 1000
                 WHERE CURRENT OF emp_cr;
         END;
      END LOOP;
   CLOSE emp_cr;
EXCEPTION
   WHEN program_error OR storage_error OR value_error OR fetch_out
THEN ROLLBACK;
   WHEN others THEN ROLLBACK;
      no := sqlcode;
      message := sqlerrm;
         INSERT INTO error VALUES(no,message);
END;
/