CREATE OR REPLACE TRIGGER tri_permit_change_emp
BEFORE
INSERT OR DELETE OR UPDATE
ON emp
DECLARE
   not_insert         EXCEPTION;
   not_delete         EXCEPTION;
   not_update_sal     EXCEPTION;
   not_working_time   EXCEPTION;
BEGIN
   IF (TO_CHAR(SYSDATE,'DY') = '日')
   OR ((TO_CHAR(SYSDATE,'HH24') < '09') OR (TO_CHAR(SYSDATE,'HH24') >= '17'))
      THEN
         IF INSERTING
            THEN RAISE not_insert;
         ELSIF DELETING 
            THEN RAISE not_delete;
         ELSIF UPDATING('SAL')
            THEN RAISE not_update_sal;
         ELSE RAISE not_working_time;
         END IF;
   ELSE NULL;
   END IF;
EXCEPTION
     WHEN not_insert
     THEN raise_application_error(-20326,'営業時間内に入力してください。');
     WHEN not_delete
     THEN raise_application_error(-20325,'営業時間内に削除してください。');
     WHEN not_update_sal
     THEN raise_application_error(-20327,'営業時間内に給与額を変更してください。');
     WHEN not_working_time
     THEN raise_application_error(-20328,'営業時間内にEMP表を変更してください。');
END;
/