CREATE OR REPLACE TRIGGER tri_audit_modify_emp
AFTER
INSERT OR DELETE OR UPDATE
ON emp
FOR EACH ROW
DECLARE
   mod_user   VARCHAR2(10);
   mod_day    DATE;
BEGIN
   mod_user := USER; 
   mod_day := SYSDATE;
      IF INSERTING 
         THEN INSERT INTO audit_table 
              VALUES(mod_user,mod_day,'EMP','INSERT',:NEW.empno);
      ELSIF DELETING
         THEN INSERT INTO audit_table
              VALUES(mod_user,mod_day,'EMP','DELETE',:OLD.empno);
      ELSIF UPDATING
         THEN INSERT INTO audit_table
              VALUES(mod_user,mod_day,'EMP','UPDATE',:OLD.empno);
      END IF;
END;
/